#!/bin/sh

PATH=$PATH:/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin
DHCPCD_CONF_FILE=/etc/dhcpcd.conf
MOD_BLACK_LIST_FILE=/etc/modprobe.d/raspi-blacklist.conf
MOD_LOAD_LIST_FILE=/etc/modules

module_load() {
    local name="$1"

    sed $MOD_BLACK_LIST_FILE -i -e "s/^\(blacklist[[:space:]]*$name\)/#\1/"
    sed $MOD_LOAD_LIST_FILE -i -e "s/^#[[:space:]]*\($name\)/\1/"

    if ! grep -q "^$name" $MOD_LOAD_LIST_FILE; then
        printf "$name\n" >> $MOD_LOAD_LIST_FILE
    fi
}

do_modules() {
    if ! [ -e $MOD_BLACK_LIST_FILE ]; then
        touch $MOD_BLACK_LIST_FILE
    fi

    module_load qmi_wwan
}

do_dhcpcd_conf() {
    local instruction="denyinterfaces wwan0"

    sed $DHCPCD_CONF_FILE -i -e "s/^#[[:space:]]*\($instruction\)/\1/"

    if ! grep -q "^$instruction" $DHCPCD_CONF_FILE; then
        printf "$instruction\n" >> $DHCPCD_CONF_FILE
    fi
}

do_service() {
    systemctl daemon-reload
    systemctl unmask lte-reconnect
}

echo "do modules ..."
do_modules

echo "do config ..."
do_dhcpcd_conf

echo "do service ..."
do_service

echo "done."

exit 0
